# SPDX-License-Identifier: MIT OR GPL-3.0-or-later
from collections.abc import Mapping
from typing import Final

from ..vrm1.human_bone import HumanBoneSpecification, HumanBoneSpecifications

MAPPING: Final[Mapping[str, HumanBoneSpecification]] = {
    "Head": HumanBoneSpecifications.HEAD,
    "RightEye": HumanBoneSpecifications.RIGHT_EYE,
    "LeftEye": HumanBoneSpecifications.LEFT_EYE,
    "Neck": HumanBoneSpecifications.NECK,
    "Spine2": HumanBoneSpecifications.UPPER_CHEST,
    "Spine1": HumanBoneSpecifications.CHEST,
    "Spine": HumanBoneSpecifications.SPINE,
    "Hips": HumanBoneSpecifications.HIPS,
    "RightShoulder": HumanBoneSpecifications.RIGHT_SHOULDER,
    "RightArm": HumanBoneSpecifications.RIGHT_UPPER_ARM,
    "RightForeArm": HumanBoneSpecifications.RIGHT_LOWER_ARM,
    "RightHand": HumanBoneSpecifications.RIGHT_HAND,
    "LeftShoulder": HumanBoneSpecifications.LEFT_SHOULDER,
    "LeftArm": HumanBoneSpecifications.LEFT_UPPER_ARM,
    "LeftForeArm": HumanBoneSpecifications.LEFT_LOWER_ARM,
    "LeftHand": HumanBoneSpecifications.LEFT_HAND,
    "RightUpLeg": HumanBoneSpecifications.RIGHT_UPPER_LEG,
    "RightLeg": HumanBoneSpecifications.RIGHT_LOWER_LEG,
    "RightFoot": HumanBoneSpecifications.RIGHT_FOOT,
    "RightToeBase": HumanBoneSpecifications.RIGHT_TOES,
    "LeftUpLeg": HumanBoneSpecifications.LEFT_UPPER_LEG,
    "LeftLeg": HumanBoneSpecifications.LEFT_LOWER_LEG,
    "LeftFoot": HumanBoneSpecifications.LEFT_FOOT,
    "LeftToeBase": HumanBoneSpecifications.LEFT_TOES,
    "RightHandThumb1": HumanBoneSpecifications.RIGHT_THUMB_METACARPAL,
    "RightHandThumb2": HumanBoneSpecifications.RIGHT_THUMB_PROXIMAL,
    "RightHandThumb3": HumanBoneSpecifications.RIGHT_THUMB_DISTAL,
    "RightHandIndex1": HumanBoneSpecifications.RIGHT_INDEX_PROXIMAL,
    "RightHandIndex2": HumanBoneSpecifications.RIGHT_INDEX_INTERMEDIATE,
    "RightHandIndex3": HumanBoneSpecifications.RIGHT_INDEX_DISTAL,
    "RightHandMiddle1": HumanBoneSpecifications.RIGHT_MIDDLE_PROXIMAL,
    "RightHandMiddle2": HumanBoneSpecifications.RIGHT_MIDDLE_INTERMEDIATE,
    "RightHandMiddle3": HumanBoneSpecifications.RIGHT_MIDDLE_DISTAL,
    "RightHandRing1": HumanBoneSpecifications.RIGHT_RING_PROXIMAL,
    "RightHandRing2": HumanBoneSpecifications.RIGHT_RING_INTERMEDIATE,
    "RightHandRing3": HumanBoneSpecifications.RIGHT_RING_DISTAL,
    "RightHandPinky1": HumanBoneSpecifications.RIGHT_LITTLE_PROXIMAL,
    "RightHandPinky2": HumanBoneSpecifications.RIGHT_LITTLE_INTERMEDIATE,
    "RightHandPinky3": HumanBoneSpecifications.RIGHT_LITTLE_DISTAL,
    "LeftHandThumb1": HumanBoneSpecifications.LEFT_THUMB_METACARPAL,
    "LeftHandThumb2": HumanBoneSpecifications.LEFT_THUMB_PROXIMAL,
    "LeftHandThumb3": HumanBoneSpecifications.LEFT_THUMB_DISTAL,
    "LeftHandIndex1": HumanBoneSpecifications.LEFT_INDEX_PROXIMAL,
    "LeftHandIndex2": HumanBoneSpecifications.LEFT_INDEX_INTERMEDIATE,
    "LeftHandIndex3": HumanBoneSpecifications.LEFT_INDEX_DISTAL,
    "LeftHandMiddle1": HumanBoneSpecifications.LEFT_MIDDLE_PROXIMAL,
    "LeftHandMiddle2": HumanBoneSpecifications.LEFT_MIDDLE_INTERMEDIATE,
    "LeftHandMiddle3": HumanBoneSpecifications.LEFT_MIDDLE_DISTAL,
    "LeftHandRing1": HumanBoneSpecifications.LEFT_RING_PROXIMAL,
    "LeftHandRing2": HumanBoneSpecifications.LEFT_RING_INTERMEDIATE,
    "LeftHandRing3": HumanBoneSpecifications.LEFT_RING_DISTAL,
    "LeftHandPinky1": HumanBoneSpecifications.LEFT_LITTLE_PROXIMAL,
    "LeftHandPinky2": HumanBoneSpecifications.LEFT_LITTLE_INTERMEDIATE,
    "LeftHandPinky3": HumanBoneSpecifications.LEFT_LITTLE_DISTAL,
}


CONFIG: Final = ("Ready Player Me", MAPPING)
